package info.textgrid.middleware;

import java.util.Arrays;
import java.util.List;

/**
 * Collection of values never changing its content
 * 
 * @author Maximilian Brodhun: SUB
 *
 */

public final class DARIAHConstants {

	private DARIAHConstants() {
		// not called
	}

	// public static boolean furtherElements = true;

	public static final String			ITEM_IDENTIFIER_PREFIX		= "hdl:";
	public static final String			COLLECTIONREGISTRY_PREFIX	= "dariah:collection";
	public static final String			COLLECTION_MIMETYPE			= "text/tg.collection+tg.aggregation+xml";
	public static final List<String>	TEXTGRID_REP_ADMIN_CONTACT	= Arrays.asList("textgrid-support@gwdg.de");

	/*
	 * Rep Identification String Constants
	 */

	// public static final String TG_REP_NAME = "TextGrid Repository";
	public static final String			DARIAH_REP_BASEURL				= "repository.de.dariah.eu";
	// public static final String TG_REP_OAIPMH_PROTOCOL_VERSION = "2.0";
	public static final String			METADATA_DC_PREFIX			= "rdf:RDF/rdf:Description";

	/*
	 * Error String Constants
	 */

	public static final String			OAI_BAD_ARGUMENT			= "BadArgument";
	public static final String			OAI_METADATA_FORMAT_ERROR	= "FormatError";
	public static final String			OAI_NO_RECORD_MATCH			= "RecordMatchError";
	public static final String			OAI_NO_SET_HIERARCHY		= "SetHierarchyError";

	/*
	 * TextGrid Metadata Fields for OAI-PMH Request (Mapping to DC)
	 */

	public static final String			CREATED						= "metadata.dc:date";
	public static final String			FORMAT						= "metadata.dc:format";
	public static final String			IDENTIFIER					= "metadata.dc:identifier";
	public static final String			DATA_CONTRIBUTOR			= "metadata.dc:contributor";

	public static final String[]		DARIAHFields				= {
			"metadata.dc:contributor", "metadata.dc:coverage",
			"metadata.dc:creator", "metadata.dc:date",
			"metadata.dc:description", "metadata.dc:format",
			"metadata.dc:identifier", "metadata.dc:language",
			"metadata.dc:publisher", "metadata.dc:relation",
			"metadata.dc:rights", "metadata.dc:source", "metadata.dc:subject",
			"metadata.dc:title", "metadata.dc:type"				};

	public static final String[]		DARIAHCollectionFields		= { "metadata.dc:title" };

	/*
	 * String Arrays to define which TextGrid fields belongs to the regarding DC
	 * fields
	 */

	public static final String[]		CONTRIBUTOR_LIST			= { "metadata.dc:contributor" };
	public static final String[]		COVERAGE_LIST				= { "metadata.dc:coverage" };
	public static final String[]		CREATOR_LIST				= { "metadata.dc:cretor" };
	public static final String[]		DATE_LIST					= { "metadata.dc:date" };
	public static final String[]		DESCRIPTION_LIST			= { "metadata.dc:description" };
	public static final String[]		FORMAT_LIST					= { "metadata.dc:format" };
	public static final String[]		IDENTIFIER_LIST				= { "metadata.dc:identifier" };
	public static final String[]		LANGUAGE_LIST				= { "metadata.dc:language" };
	public static final String[]		PUBLISHER_LIST				= { "metadata.dc:publisher" };
	public static final String[]		RELATIONS_LIST				= { "metadata.dc:relation" };
	public static final String[]		RIGHTS_LIST					= { "metadata.dc:rights" };
	public static final String[]		SOURCE_LIST					= { "metadata.dc:source" };
	public static final String[]		SUBJECT_LIST				= { "metadata.dc:subject" };
	public static final String[]		TITLE_LIST					= { "metadata.dc:title" };
	public static final String[]		TYPE_LIST					= { "metadata.dc:type" };
	public static final String[]		IDENTIFIER_LIST_FIELDS		= {
			"metadata.dc:identifier", "metadata.dc:date", "metadata.dc:format" };
	public static final String			RANGE_FIELD					= "metadata.dc:date";

}
