package info.textgrid.middleware;

import java.text.ParseException;
import java.util.ArrayList;
import java.util.List;

import javax.xml.datatype.DatatypeConfigurationException;

import org.apache.commons.logging.LogFactory;
import org.elasticsearch.action.get.GetResponse;
import org.elasticsearch.search.SearchHit;

public class DublinCoreFieldLoader {

	public static List<String>						contributors	= new ArrayList<String>();
	public static List<String>						coverages		= new ArrayList<String>();
	public static List<String>						creators		= new ArrayList<String>();
	public static List<String>						dates			= new ArrayList<String>();
	public static List<String>						descriptions	= new ArrayList<String>();
	public static List<String>						formats			= new ArrayList<String>();
	public static List<String>						identifiers		= new ArrayList<String>();
	public static List<String>						languages		= new ArrayList<String>();
	public static List<String>						publishers		= new ArrayList<String>();
	public static List<String>						relations		= new ArrayList<String>();
	public static List<String>						rights			= new ArrayList<String>();
	public static List<String>						sources			= new ArrayList<String>();
	public static List<String>						subjects		= new ArrayList<String>();
	public static List<String>						titles			= new ArrayList<String>();
	public static List<String>						types			= new ArrayList<String>();

	public static String							collectionTitle;

	private static org.apache.commons.logging.Log	log				= LogFactory
																			.getLog(RecordDeliverer.class);

	// ----DC-Contributor

	public static List<String> setContributor(SearchHit hit, String[] values) {

		for (String field : values) {
			if (hit.getFields().get(field) != null) {
				contributors.add(hit.getFields().get(field).values().get(0)
						.toString());
			}
		}

		return contributors;
	}

	public static List<String> setContributor(GetResponse responseWorkValues, String[] values) {
		if(responseWorkValues.isExists()){
			for (String field : values) {
				if (responseWorkValues.getField(field) != null) {
					contributors.add(responseWorkValues.getField(field).getValue().toString());
				}
			}
		}

		return contributors;
	}

	// ----DC-Creator

	public static List<String> setCreator(GetResponse responseWorkValues, String[] values) {
		if(responseWorkValues.isExists()){
			for (String field : values) {
				if (responseWorkValues.getField(field) != null) {
					creators.add(responseWorkValues.getField(field).getValue().toString());
				}
			}
		}
		return creators;
	}

	public static List<String> setCreator(SearchHit hit, String[] values) {

		for (String field : values) {
			if (hit.getFields().get(field) != null) {
				creators.add(hit.getFields().get(field).values().get(0)
						.toString());
			}
		}

		return creators;
	}

	// ----DC-Coverage

	public static List<String> setCoverage(GetResponse responseWorkValues, String[] values) {
      if(responseWorkValues.isExists()){
		for (String field : values) {
			System.out.println("fieldname: " + field);
			System.out.println(responseWorkValues.isExists());
			if (responseWorkValues.getField(field) != null) {
					coverages.add(responseWorkValues.getField(field).getValue().toString());
			}

		}
      }
		return coverages;
	}

	public static List<String> setCoverage(SearchHit hit, String[] values) {

		for (String field : values) {
			if (hit.getFields().get(field) != null) {
				coverages.add(hit.getFields().get(field).values().get(0)
						.toString());
			}
		}

		return coverages;
	}

	// ----DC-Date

	public static List<String> setDate(GetResponse responseWorkValues, String[] values) {
      
		if(responseWorkValues.isExists()){
			for (String field : values) {
				try {
					// FIXME DO SET VALUES VIA CONFIG FILE!
					System.out.println("fieldname: "+ field);
				
					if (responseWorkValues.getField(field) != null) {
						dates.add(OAIPMHUtillities.convertDateFormat(responseWorkValues.getField(field).getValue()
									.toString()).toXMLFormat());
					}
				} catch (ParseException e) {
					System.out.println("fieldname: "+ field);
					// FIXME DO NOT USE INVALID DATE HERE!
					dates.add(responseWorkValues.getField(field).getValue().toString());
					log.debug(e);
				} catch (DatatypeConfigurationException e) {
					System.out.println("fieldname: "+ field);
					// FIXME DO NOT USE INVALID DATE HERE!
					dates.add(responseWorkValues.getField(field).getValue().toString());
				log.debug(e);
				}
			}
		}
		return dates;
	}

	public static List<String> setDate(SearchHit hit, String[] values) {

		for (String field : values) {
			if (hit.getFields().get(field) != null) {
				dates.add(hit.getFields().get(field).values().get(0).toString());
			}
		}

		return dates;
	}

	// ----DC-Description

	public static List<String> setDescription(GetResponse responseWorkValues, String[] values) {
		if(responseWorkValues.isExists()){
			for (String field : values) {
				if (responseWorkValues.getField(field) != null) {
					descriptions.add(responseWorkValues.getField(field).getValue().toString());
				}
			}
		}
		return descriptions;
	}

	public static List<String> setDescription(SearchHit hit, String[] values) {

		for (String field : values) {
			if (hit.getFields().get(field) != null) {
				descriptions.add(hit.getFields().get(field).values().get(0)
						.toString());
			}
		}

		return descriptions;
	}

	// ----DC-Format

	public static List<String> setFormat(SearchHit hit, String[] values) {

		for (String field : values) {
			if (hit.getFields().get(field) != null) {
				formats.add(hit.getFields().get(field).values().get(0)
						.toString());
			}
		}

		return formats;
	}

	public static List<String> setFormat(GetResponse responseWorkValues,
			String[] values) {
		if(responseWorkValues.isExists()){
			for (String field : values) {
				if (responseWorkValues.getField(field) != null) {
					formats.add(responseWorkValues.getField(field).getValue().toString());
				}
			}
		}
		return formats;
	}

	// ----DC-Identifier

	public static List<String> setIdentifier(SearchHit hit, String[] values) {
		for (String field : values) {
			if (hit.getFields().get(field) != null) {
				for (int i = 0; i < hit.getFields().get(field).getValues()
						.size(); i++) {
					identifiers.add(hit.getFields().get(field).values().get(i)
							.toString());
				}
			}
		}

		return identifiers;
	}

	public static List<String> setIdentifier(GetResponse responseWorkValues, String[] values) {
		if(responseWorkValues.isExists()){
			for (String field : values) {
				if (responseWorkValues.getField(field) != null) {
					identifiers.add(responseWorkValues.getField(field).getValue().toString());
				}
			}
		}

		return identifiers;
	}

	// ----DC-Language

	public static List<String> setLanguage(SearchHit hit, String[] values) {

		for (String field : values) {
			if (hit.getFields().get(field) != null) {
				languages.add(hit.getFields().get(field).values().get(0).toString());
			}
		}

		return languages;
	}

	public static List<String> setLanguage(GetResponse responseWorkValues,String[] values) {
		if(responseWorkValues.isExists()){
			for (String field : values) {
				if (responseWorkValues.getField(field) != null) {
					languages.add(responseWorkValues.getField(field).getValue().toString());
				}
			}
		}
		
		return languages;
	}

	// ----DC-Publisher

	public static List<String> setPublisher(SearchHit hit, String[] values) {

		for (String field : values) {
			if (hit.getFields().get(field) != null) {
				publishers.add(hit.getFields().get(field).values().get(0).toString());
			}
		}

		return publishers;
	}

	public static List<String> setPublisher(GetResponse responseWorkValues,	String[] values) {
		if(responseWorkValues.isExists()){
			for (String field : values) {
				if (responseWorkValues.getField(field) != null) {
					publishers.add(responseWorkValues.getField(field).getValue().toString());
				}
			}
		}
		
		return publishers;
	}

	// ----DC-Relation

	public static List<String> setRelation(SearchHit hit, String[] values) {

		for (String field : values) {
			if (hit.getFields().get(field) != null) {
				for (int i = 0; i < hit.getFields().get(field).getValues().size(); i++) {
					relations.add(hit.getFields().get(field).values().get(i).toString());
				}
			}
		}

		return relations;
	}

	public static List<String> setRelation(GetResponse responseWorkValues, String[] values) {
		if(responseWorkValues.isExists()){
			for (String field : values) {
				if (responseWorkValues.getField(field) != null) {
					relations.add(responseWorkValues.getField(field).getValue().toString());
				}
			}
		}
		
		return relations;
	}

	public static List<String> setRelationForWork(GetResponse responseWorkValues, String[] values) {
		if(responseWorkValues.isExists()){
			for (String field : values) {
				if (responseWorkValues.getField(field) != null) {
					relations.add(responseWorkValues.getField(field).getValue().toString());
				}
			}
		}
		
		return relations;
	}

	// ----DC-Right

	public static List<String> setRights(SearchHit hit, String[] values) {

		for (String field : values) {
			if (hit.getFields().get(field) != null) {
				rights.add(hit.getFields().get(field).values().get(0).toString());
			}
		}

		return rights;
	}

	public static List<String> setRights(GetResponse responseWorkValues, String[] values) {
		if(responseWorkValues.isExists()){
			for (String field : values) {
				if (responseWorkValues.getField(field) != null) {
					rights.add(responseWorkValues.getField(field).getValue().toString());
				}
			}
		}
		
		return rights;
	}

	// ----DC-Source

	public static List<String> setSources(SearchHit hit, String[] values) {

		for (String field : values) {
			if (hit.getFields().get(field) != null) {
				sources.add(hit.getFields().get(field).values().get(0).toString());
			}
		}

		return sources;
	}

	public static List<String> setSources(GetResponse responseWorkValues, String[] values) {
		if(responseWorkValues.isExists()){
			for (String field : values) {
				if (responseWorkValues.getField(field) != null) {
					sources.add(responseWorkValues.getField(field).getValue().toString());
				}
			}
		}
		
		return sources;
	}

	// ----DC-Subject

	public static List<String> setSubject(GetResponse responseWorkValues, String[] values) {
		
		for (String field : values) {
			if (responseWorkValues.getField(field) != null) {
				subjects.add(responseWorkValues.getField(field).getValue().toString());
			}
		}

		return subjects;
	}

	public static List<String> setSubject(SearchHit hit, String[] values) {
		
		for (String field : values) {
			if (hit.getFields().get(field) != null) {
				subjects.add(hit.getFields().get(field).values().get(0).toString());
			}
		}

		return subjects;
	}

	// ----DC-Title

	public static List<String> setTitle(SearchHit hit, String[] values) {

		for (String field : values) {
			if (hit.getFields().get(field) != null) {
				for (int i = 0; i < hit.getFields().get(field).getValues().size(); i++) {
					titles.add(hit.getFields().get(field).values().get(i).toString());
				}
			}
		}

		return titles;
	}

	public static List<String> setTitle(GetResponse responseWorkValues,
			String[] values) {
		if(responseWorkValues.isExists()){
			for (String field : values) {
				if (responseWorkValues.getField(field) != null) {
					for (int i = 0; i < responseWorkValues.getField(field).getValues().size(); i++) {
						titles.add(responseWorkValues.getField(field).getValue().toString());
					}
				}
			}
		}
		
		return titles;
	}

	// ----DC-Type

	public static List<String> setType(GetResponse responseWorkValues, String[] values) {
		if(responseWorkValues.isExists()){
			if (values != null) {
				for (String field : values) {
					if (responseWorkValues.getField(field) != null) {
						types.add(responseWorkValues.getField(field).getValue().toString());
					}
				}
			}
		}
		
		return types;
	}

	public static List<String> setType(SearchHit hit, String[] values) {

		for (String field : values) {
			if (hit.getFields().get(field) != null) {
				for (int i = 0; i < hit.getFields().get(field).getValues()
						.size(); i++) {
					types.add(hit.getFields().get(field).values().get(i)
							.toString());
				}
			}
		}

		return types;
	}
}
