package info.textgrid.middleware;

import java.text.ParseException;

import javax.xml.bind.JAXBElement;

import org.apache.cxf.jaxrs.client.JAXRSClientFactory;

import info.textgrid.middleware.oaipmh.OAIPMHType;




public class OaiPmhClient {

	private String identifier;
	private String metadataPrefix;
	private String set;
	private String from;
	private String until;
	private String resumptionToken;

	private OAIPMHProducer producer;
	
	public OaiPmhClient(String endpoint){
		
		this.producer = JAXRSClientFactory.create(endpoint + "/oai", OAIPMHProducer.class);
				
	}
	
	
	public JAXBElement<OAIPMHType> request(String verb) throws ParseException{
		
		return producer.getRequest(verb, identifier, metadataPrefix, set, from, until, resumptionToken);
		
	}
	
}
