package info.textgrid.middleware;

import info.textgrid.middleware.oaipmh.DeletedRecordType;
import info.textgrid.middleware.oaipmh.GranularityType;
import info.textgrid.middleware.oaipmh.RequestType;

/**
 * Handling the "Identify" request from an OAIPMH client
 * 
 * @author Maximilian Brodhun, SUB
 * @version 1.0
 * @since 11.02.2014
 *
 */
public class RepIdentification {

	private DeletedRecordType tgDeletetObjects = DeletedRecordType.NO;
	private GranularityType tgRepGranulartiry = GranularityType.YYYY_MM_DD_THH_MM_SS_Z;
	
	private String RepositoryName;
	private String BaseUrl;
	private String EarliestDatestamp;
	private String ProtocolVersion;
	private String AdminMailAdress;
	
	
	public RepIdentification(String RepositoryName, 
			 String BaseUrl,
			 DeletedRecordType DeletedRecordInfo,
			 String EarliestDatestamp,
			 GranularityType Granularity,
			 String ProtocolVersion,
			 String AdminMail){
		
		setRepositoryName(RepositoryName);
		setBaseUrl(BaseUrl);
		setDeletedRecordStatus(DeletedRecordInfo);
		setEarliestDatestamp(EarliestDatestamp);
		setGranularity(Granularity);
		setProtocolVersion(ProtocolVersion);
		setAdminMailAddress(AdminMail);
	}

	
	/**
	 * 
	 * @return TGConstants.TG_REP_NAME;
	 */
	public String getRepositoryName(){
		//return TGConstants.TG_REP_NAME;
		System.out.println("testitest" + RepositoryName);
		return RepositoryName;
	}
	
	public void setRepositoryName(String RepositoryName){
		this.RepositoryName = RepositoryName;
	}
	
	/**
	 * 
	 * @return TGConstants.TG_REP_BASEURL
	 */
	public String getBaseUrl(){
		//return TGConstants.TG_REP_BASEURL;
		return BaseUrl;
	}
	
	public void setBaseUrl(String BaseUrl){
		this.BaseUrl = BaseUrl;
	}
		
	/**
	 * 
	 * @return tgDeletetObjects
	 */
	public DeletedRecordType getDeletedRecordStatus(){
		return tgDeletetObjects;
	}
	
	public void setDeletedRecordStatus(DeletedRecordType tgDeletetObjects){
		this.tgDeletetObjects = tgDeletetObjects;
	}
	
	/**
	 * 
	 * @return "2011-06-11T2:32:40Z"
	 */
	public String getEarliestDatestamp(){
		//return "2011-06-11T02:32:40Z";
		return EarliestDatestamp;
	}
	
	public void setEarliestDatestamp(String earliestDatestamp){
		this.EarliestDatestamp = earliestDatestamp;
	}
	
	/**
	 * 
	 * @return tgRepGranulartiry
	 */
	public GranularityType getGranularity(){
		return tgRepGranulartiry;
	}
	
	public void setGranularity(GranularityType tgRepGranulartiry){
		this.tgRepGranulartiry = tgRepGranulartiry; 
	}
	
	/**
	 * 
	 * @return TGConstants.TG_REP_OAIPMH_PROTOCOL_VERSION;
	 */
	public String getProtocolVersion(){
		//return TGConstants.TG_REP_OAIPMH_PROTOCOL_VERSION;
		return ProtocolVersion;
	}
	
	public void setProtocolVersion(String protocolVersion){
		this.ProtocolVersion = protocolVersion;
	}
	
	/**
	 * 
	 * @return TGConstants.TEXTGRID_REP_ADMIN_CONTACT.get(0)
	 */
	public String getAdminMaiAddresss(){
		//return TGConstants.TEXTGRID_REP_ADMIN_CONTACT.get(0);
		return AdminMailAdress;
	}
	
	public void setAdminMailAddress(String adminMailAddress){
		this.AdminMailAdress = adminMailAddress;
	}
	
	/**
	 * checking the request if all necessary values are set or not allowed values are not set
	 * @param request the initially request from the OAIPMG client
	 * @return a boolean indicating the correctness of the request
	 */
	
	public boolean requestChecker(RequestType request){
		
		boolean noArguments;
		
		if( request.getFrom()!=null || 
			request.getIdentifier()!=null || 
			request.getMetadataPrefix()!=null 
		   ){
				noArguments=false;
		}
		else if(request.getResumptionToken()!=null || 
				request.getSet()!=null || 
				request.getUntil()!=null){
			
				noArguments=false;
		}
		else{
			noArguments=true;
		}
		return noArguments;
	}
	
}
