package info.textgrid.middleware;

import info.textgrid.utils.httpclient.TGHttpConnection;

import java.io.IOException;
import java.io.InputStream;
import java.util.Properties;

import javax.ws.rs.GET;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;
import javax.ws.rs.core.Response;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

public class Rest {

	private Log	log	= LogFactory.getLog(Rest.class);

	@GET
	@Path("/getVersion/")
	@Produces("text/html")
	public String getVersion() {

		InputStream is = this.getClass().getResourceAsStream("buildinfo.txt");
		Properties prop = new Properties();
		try {
			prop.load(is);
		} catch (IOException e) {
			return "Error opening buildinfo.txt";
		} finally {
			try {
				is.close();
			} catch (IOException e) {
				log.error("error closing stream", e);
			}
		}

		String info = "This is oaipmh " + prop.get("version") + " built "
				+ prop.get("time") + " from git: " + prop.get("branch")
				+ " (rev:" + prop.get("build") + ")";

		return info;
	}

	@GET
	@Path("/cmstat")
	@Produces("text/plain")
	public Response getConManStat() {

		String[] routes = {};
		String cmstats = TGHttpConnection.generateInfoString(routes);

		return Response.ok(cmstats).build();
	}

}
