package info.textgrid.middleware;

import info.textgrid.middleware.oaipmh.ListSetsType;
import info.textgrid.middleware.oaipmh.SetType;


import java.util.LinkedHashSet;
import java.util.Set;

import org.elasticsearch.action.get.GetRequestBuilder;
import org.elasticsearch.action.get.GetResponse;
import org.elasticsearch.action.search.SearchRequestBuilder;
import org.elasticsearch.action.search.SearchResponse;
import org.elasticsearch.index.query.QueryBuilders;
import org.elasticsearch.index.query.QueryStringQueryBuilder;
import org.elasticsearch.search.SearchHit;

public class SetDeliverer {

	private OAI_ESClient	oaiEsClient;

	public SetDeliverer(OAI_ESClient oaiEsClient) {
		this.oaiEsClient = oaiEsClient;
	}

	private Set<String>	identifier			= new LinkedHashSet<String>();
    private String formatField;
    private String formatToFilter;
    private String identifierField;
    private String repositoryObjectURIPrefix;
    private String specField;
    private String specFieldPrefix;

	public ListSetsType setListBuilder() {
		System.out.println("start set deliverer");
		ListSetsType setList = new ListSetsType();

		QueryStringQueryBuilder aggQuery = QueryBuilders.queryString("*");

		SearchRequestBuilder request = this.oaiEsClient.getOaiESClient()
				.prepareSearch(this.oaiEsClient.getEsIndex())
				.setTypes(this.oaiEsClient.getEsType()).setQuery(aggQuery)
				.addField(formatField)//metadata.dc:format
				.addField(identifierField).setSize(100000); //"metadata.dc:identifier"

		SearchResponse getRecordListItems = request.execute().actionGet();

		for (SearchHit hit : getRecordListItems.getHits().getHits()) {
			System.out.println("indside for loop");
			System.out.println("formatField: " + formatField);
			System.out.println("formatToFilter: " + formatToFilter);
			if(hit.getFields().get(formatField) != null && hit.getFields().get(formatField).value()
			.equals(formatToFilter)) {
				
				System.out.println("identifierField: " + identifierField);
				System.out.println("identifier: " + identifier);
				this.identifier.add(hit.getFields()
						.get(identifierField).values().get(0)
						.toString());
			}
		}

		for (String identifierSetSpec : this.identifier) {
			System.out.println("indside second for loop");
			String id = identifierSetSpec;
			if (identifierSetSpec
					.startsWith(repositoryObjectURIPrefix)) { //hdl:
				id = identifierSetSpec
						.substring(repositoryObjectURIPrefix
								.length());
			}

			GetRequestBuilder collectionNameById = this.oaiEsClient
					.getOaiESClient().prepareGet()
					.setIndex(this.oaiEsClient.getEsIndex())
					.setType(this.oaiEsClient.getEsType())
					.setFields(specField).setId(id); //metadata.dc:title
			
			System.out.println("process the getRequest");

			GetResponse setSpec = collectionNameById.execute().actionGet();

			String setName = "";
			if (setSpec != null
					&& setSpec.getField(specField) != null) {
				System.out.println("building sets");
				setName = setSpec.getField(specField)
						.getValue().toString();
			}

			SetType set = new SetType();

			set.setSetName(setName);
			set.setSetSpec(specFieldPrefix + ":" + id);

			setList.getSet().add(set);
		}
		identifier.clear();
		return setList;

	}
	
	public String getFormatField() {
		return formatField;
	}
	public void setFormatField(String formatField) {
		this.formatField = formatField;
	}

	public String getFormatToFilter() {
		return formatToFilter;
	}

	public void setFormatToFilter(String formatToFilter) {
		this.formatToFilter = formatToFilter;
	}

	public String getIdentifierField() {
		return identifierField;
	}

	public void setIdentifierField(String identifierField) {
		this.identifierField = identifierField;
	}

	public String getRepositoryObjectURIPrefix() {
		return repositoryObjectURIPrefix;
	}

	public void setRepositoryObjectURIPrefix(String repositoryObjectURIPrefix) {
		this.repositoryObjectURIPrefix = repositoryObjectURIPrefix;
	}

	public String getSpecField() {
		return specField;
	}

	public void setSpecField(String titleField) {
		this.specField = titleField;
	}

	public String getSpecFieldPrefix() {
		return specFieldPrefix;
	}

	public void setSpecFieldPrefix(String specFieldPrefix) {
		this.specFieldPrefix = specFieldPrefix;
	}
}
