package info.textgrid.middleware;

import java.text.ParseException;

import info.textgrid.middleware.oaipmh.DeletedRecordType;
import info.textgrid.middleware.oaipmh.GranularityType;
import info.textgrid.middleware.oaipmh.OAIPMHType;
import info.textgrid.namespaces.middleware.tgcrud.common.TextGridMimetypes;

import javax.xml.bind.JAXB;
import javax.xml.bind.JAXBElement;
import javax.xml.datatype.DatatypeConfigurationException;
import javax.xml.datatype.XMLGregorianCalendar;

import org.junit.BeforeClass;
import org.junit.Ignore;
import org.junit.Test;

/**
 *
 */

public class OaiPmhTest {

	private static OAI_ESClient oaiEsClient;
	DeletedRecordType bla = DeletedRecordType.NO;
	GranularityType bla2 = GranularityType.YYYY_MM_DD_THH_MM_SS_Z;
	private RepIdentification rep = new RepIdentification(
			"TextGrid-Repository", "www.textgridrep.de", this.bla,
			"2011-06-11T02:32:40Z", this.bla2, "2.0",
			"textgrid-support@gwdg.de");
	// private RecordDeliverer record = new RecordDeliverer(
	// oaiEsClient,
	// TGConstants.TGWorkFields,
	// true, false);
	private RecordDeliverer record = new RecordDeliverer(oaiEsClient,
			DARIAHConstants.DARIAHFields, false, true);
	private RecordListDeliverer recordList = new RecordListDeliverer(
			oaiEsClient, DARIAHConstants.DARIAHFields,
			DARIAHConstants.DARIAHCollectionFields, false, true);
	private boolean textgrid;
	private boolean dariah;
	// private RecordListDeliverer recordList = new
	// RecordListDeliverer(oaiEsClient, TGConstants.TGFields,
	// TGConstants.TGWorkFields, true, false);
	private MetadataFormatListDeliverer metadataFormatList = new MetadataFormatListDeliverer(
			oaiEsClient);
	private SetDeliverer setList = new SetDeliverer(oaiEsClient);
	private IdentifierListDeliverer identifierList = new IdentifierListDeliverer(
			oaiEsClient, true, false);

	private OAIPMHImpl request = new OAIPMHImpl(oaiEsClient, this.rep,
			this.record, this.recordList, this.metadataFormatList,
			this.setList, this.identifierList);

	/**
	 * @throws Exception
	 */
	@BeforeClass
	public static void setUp() throws Exception {

		// oaiEsClient = new OAI_ESClient("localhost", 9302,
		// "dariah-repository-prototype");

		oaiEsClient = new OAI_ESClient("localhost", 9302,
				"tg-dev1-test-instance");
		// oaiEsClient.setEsIndex("textgrid-public");
		// oaiEsClient.setEsType("metadata");
		oaiEsClient.setEsIndex("dariahreptest");
		oaiEsClient.setEsType("oai");
	}

	/**
	 * @throws DatatypeConfigurationException
	 */
	@Test
	@Ignore
	public void testDateNow() throws DatatypeConfigurationException {
		System.out.println("---------------Now Version-----------------");
		XMLGregorianCalendar nowTest = OAIPMHUtillities
				.getXMLGregorianCalendarNow();
		System.out.println(nowTest);
		System.out.println("-------------------------------------------");
	}

	/**
	 * @throws ParseException
	 * @throws DatatypeConfigurationException
	 */
	@Test
	@Ignore
	public void testDateGregorianType() throws ParseException,
			DatatypeConfigurationException {
		String dateformatbefore = "2012-02-06T20:48:39.614+01:00";

		System.out.println("---------XML Gregorian Version---------------");
		System.out.println("Original date: " + dateformatbefore);
		XMLGregorianCalendar testDate = OAIPMHUtillities
				.convertDateFormat(dateformatbefore);
		System.out.println("Date after conversion: " + testDate);
		System.out.println("---------------------------------------------");
	}

	/**
	 * @throws ParseException
	 * @throws DatatypeConfigurationException
	 */
	@Test
	@Ignore
	public void testDateStringType() throws ParseException,
			DatatypeConfigurationException {
		String dateformatbefore = "2012-02-06T20:48:39.614+01:00";

		System.out.println("------------String Version-------------------");
		System.out.println("Original date: " + dateformatbefore);
		String testDate = OAIPMHUtillities.datestampAsString(dateformatbefore);
		System.out.println("Date after conversion: " + testDate);
		System.out.println("---------------------------------------------");
	}

	/**
	 * @throws ParseException
	 */
	@Test
	@Ignore
	public void testGetRequestIdentify() throws ParseException {

		System.out
				.println("Test for the verb \"Identify\" with succesfull response");
		JAXBElement<OAIPMHType> r = this.request.getRequest("Identify", "", "",
				"", "", "", "");
		JAXB.marshal(r, System.out);
		System.out.println("-----------------------------------\n");
	}

	/**
	 * @throws ParseException
	 */
	@Test
	@Ignore
	public void testGetRequestIdentifyVerbError() throws ParseException {
		JAXBElement<OAIPMHType> t = this.request.getRequest("Identify", "",
				"a", "", "", "", "");
		JAXB.marshal(t, System.out);
		System.out.println("-----------------------------------\n");
	}

	/**
	 * @throws ParseException
	 */
	@Test
	@Ignore
	public void testGetRequestIdentifyArgumentError() throws ParseException {
		System.out
				.println("Test for the verb \"Identify\" with error response");
		JAXBElement<OAIPMHType> z = this.request.getRequest("Identify", "a",
				"", "", "", "a", "");
		JAXB.marshal(z, System.out);
		System.out.println("-----------------------------------\n");
	}

	/**
	 * @throws ParseException
	 */
	@Test
	@Ignore
	public void testGetRequestGetRecordError() throws ParseException {

		System.out
				.println("Test for the verb \"GetRecord\" with succesfull response");
		JAXBElement<OAIPMHType> t = this.request.getRequest("GetRecord",
				"textgrid:vqn0.0", "oai_dc", "", "", "", "");
		JAXB.marshal(t, System.out);
		System.out.println("-----------------------------------\n");
	}

	/**
	 * @throws ParseException
	 */
	@Test
	@Ignore
	public void testGetRequestGetRecordError2() throws ParseException {

		this.record.setContributor(TGConstants.CONTRIBUTOR_LIST);
		this.record.setCoverage(TGConstants.COVERAGE_LIST);
		this.record.setCreator(TGConstants.CREATOR_LIST);
		this.record.setDates(TGConstants.DATE_LIST);
		this.record.setDescriptions(TGConstants.DESCRIPTION_LIST);
		this.record.setFormats(TGConstants.FORMAT_LIST);
		this.record.setIdentifiers(TGConstants.IDENTIFIER_LIST);
		this.record.setLanguages(TGConstants.LANGUAGE_LIST);
		this.record.setPublishers(TGConstants.PUBLISHER_LIST);
		this.record.setRelations(TGConstants.RELATIONS_LIST);
		this.record.setRelationsForWork(TGConstants.RELATIONS_FOR_WORK_LIST);
		this.record.setRights(TGConstants.RIGHTS_LIST);
		this.record.setSources(TGConstants.SOURCE_LIST);
		this.record.setSubjects(TGConstants.SUBJECT_LIST);
		this.record.setTitles(TGConstants.TITLE_LIST);
		this.record.setTypes(TGConstants.TYPE_LIST);
		this.record.setFields(TGConstants.TGFields);
		this.record.setFormatField(TGConstants.FORMAT);
		this.record.setFormatToFilter(TextGridMimetypes.EDITION);
		this.record.setDateOfObjectCreation(TGConstants.CREATED);
		this.record
				.setRelationToFurtherMetadataObject(TGConstants.EDITION_ISEDITIONOF);
		this.record
				.setRepositoryObjectURIPrefix(TGConstants.ITEM_IDENTIFIER_PREFIX);
		this.record.setIdentifierField("textgridUri");

		System.out
				.println("Test for the verb \"GetRecord\" with succesfull response");
		JAXBElement<OAIPMHType> p = this.request.getRequest("GetRecord",
				"970.0", "oai_dc", "", "", "", "");
		JAXB.marshal(p, System.out);
		System.out.println("-----------------------------------\n");
	}

	/**
	 * @throws ParseException
	 */
	@Test
	@Ignore
	public void testGetRequestGetRecordDariah() throws ParseException {

		this.record.setContributor(DARIAHConstants.CONTRIBUTOR_LIST);
		this.record.setCoverage(DARIAHConstants.COVERAGE_LIST);
		this.record.setCreator(DARIAHConstants.CREATOR_LIST);
		this.record.setDates(DARIAHConstants.DATE_LIST);
		this.record.setDescriptions(DARIAHConstants.DESCRIPTION_LIST);
		this.record.setFormats(DARIAHConstants.FORMAT_LIST);
		this.record.setIdentifiers(DARIAHConstants.IDENTIFIER_LIST);
		this.record.setLanguages(DARIAHConstants.LANGUAGE_LIST);
		this.record.setPublishers(DARIAHConstants.PUBLISHER_LIST);
		this.record.setRelations(DARIAHConstants.RELATIONS_LIST);
		// record.setRelationsForWork(DARIAHConstants.RELATIONS_FOR_WORK_LIST);
		this.record.setRights(DARIAHConstants.RIGHTS_LIST);
		this.record.setSources(DARIAHConstants.SOURCE_LIST);
		this.record.setSubjects(DARIAHConstants.SUBJECT_LIST);
		this.record.setTitles(DARIAHConstants.TITLE_LIST);
		this.record.setTypes(DARIAHConstants.TYPE_LIST);
		this.record.setFields(DARIAHConstants.DARIAHFields);
		this.record.setFormatField(DARIAHConstants.FORMAT);
		this.record.setFormatToFilter("metadata");
		this.record.setDateOfObjectCreation(DARIAHConstants.CREATED);
		// record.setRelationToFurtherMetadataObject(DARIAHConstants.EDITION_ISEDITIONOF);
		this.record
				.setRepositoryObjectURIPrefix(DARIAHConstants.ITEM_IDENTIFIER_PREFIX);
		this.record.setIdentifierField("metadata.dc:identifier");

		System.out
				.println("Test for the verb \"GetRecord\" with succesfull response");
		JAXBElement<OAIPMHType> p = this.request.getRequest("GetRecord",
				"hdl:11022/0000-0000-46FE-4", "oai_dc", "", "", "", "");
		JAXB.marshal(p, System.out);
		System.out.println("-----------------------------------\n");
	}

	/**
	 * @throws ParseException
	 */
	@Test
	@Ignore
	public void testGetRequestGetRecordError3() throws ParseException {
		System.out
				.println("Test for the verb \"GetRecord\" with succesfull response");
		JAXBElement<OAIPMHType> p = this.request.getRequest("GetRecord", "",
				"", "", "", "", "");
		JAXB.marshal(p, System.out);
		System.out.println("-----------------------------------\n");

	}

	/**
	 * @throws ParseException
	 */
	@Test
	@Ignore
	public void testListIdentifierSets() throws ParseException {
		System.out
				.println("Test for the verb \"ListIdentifiers\" with succesfull response");
		JAXBElement<OAIPMHType> p = this.request.getRequest("ListIdentifiers",
				"", "oai_dc", "project.value:St. Matthias Test 07", "", "", "");
		JAXB.marshal(p, System.out);
		System.out.println("-----------------------------------\n");

	}

	/**
	 * @throws ParseException
	 */
	@Test
	@Ignore
	public void testListRecordSets() throws ParseException {
		System.out
				.println("Test for the verb \"ListRecord\" with sets with succesfull response");
		JAXBElement<OAIPMHType> p = this.request.getRequest("ListRecords", "",
				"oai_dc", "project.value:Digitale Bibliothek", "", "", "");
		JAXB.marshal(p, System.out);
		System.out.println("-----------------------------------\n");

	}

	/**
	 * @throws ParseException
	 */
	@Test
	@Ignore
	public void testListRecords() throws ParseException {

		JAXBElement<OAIPMHType> r = this.request.getRequest("ListRecords", "",
				"oai_dc", "", "2011-02-06T20:48:39", "", "");
		JAXB.marshal(r, System.out);
		System.out.println("-----------------------------------\n");
	}

	/**
	 * @throws ParseException
	 */
	@Test
	@Ignore
	public void testListRecords2() throws ParseException {

		this.recordList.setContributor(TGConstants.CONTRIBUTOR_LIST);
		this.recordList.setCoverage(TGConstants.COVERAGE_LIST);
		this.recordList.setCreators(TGConstants.CREATOR_LIST);
		this.recordList.setDates(TGConstants.DATE_LIST);
		this.recordList.setDescriptions(TGConstants.DESCRIPTION_LIST);
		this.recordList.setFormats(TGConstants.FORMAT_LIST);
		this.recordList.setIdentifiers(TGConstants.IDENTIFIER_LIST);
		this.recordList.setLanguages(TGConstants.LANGUAGE_LIST);
		this.recordList.setPublishers(TGConstants.PUBLISHER_LIST);
		this.recordList.setRelations(TGConstants.RELATIONS_LIST);
		this.recordList
				.setRelationsForWork(TGConstants.RELATIONS_FOR_WORK_LIST);
		this.recordList.setRights(TGConstants.RIGHTS_LIST);
		this.recordList.setSources(TGConstants.SOURCE_LIST);
		this.recordList.setSubjects(TGConstants.SUBJECT_LIST);
		this.recordList.setTitles(TGConstants.TITLE_LIST);
		this.recordList.setTypes(TGConstants.TYPE_LIST);
		this.recordList.setFormatField(TGConstants.FORMAT);
		this.recordList.setFormatToFilter(TextGridMimetypes.EDITION);
		this.recordList.setDateOfObjectCreation(TGConstants.CREATED);
		this.recordList
				.setRelationToFurtherMetadataObject(TGConstants.EDITION_ISEDITIONOF);
		this.recordList
				.setRepositoryObjectURIPrefix(TGConstants.ITEM_IDENTIFIER_PREFIX);
		this.recordList.setFieldForRange(TGConstants.CREATED);

		JAXBElement<OAIPMHType> r = this.request.getRequest("ListRecords", "",
				"oai_dc", "", "2014-02-06T20:48:39", "", "");
		JAXB.marshal(r, System.out);
		System.out.println("-----------------------------------\n");
	}

	/**
	 * @throws ParseException
	 */
	@Test
	@Ignore
	public void testListRecordsDariah() throws ParseException {

		this.recordList.setContributor(DARIAHConstants.CONTRIBUTOR_LIST);
		this.recordList.setCoverage(DARIAHConstants.COVERAGE_LIST);
		this.recordList.setCreators(DARIAHConstants.CREATOR_LIST);
		this.recordList.setDates(DARIAHConstants.DATE_LIST);
		this.recordList.setDescriptions(DARIAHConstants.DESCRIPTION_LIST);
		this.recordList.setFormats(DARIAHConstants.FORMAT_LIST);
		this.recordList.setIdentifiers(DARIAHConstants.IDENTIFIER_LIST);
		this.recordList.setLanguages(DARIAHConstants.LANGUAGE_LIST);
		this.recordList.setPublishers(DARIAHConstants.PUBLISHER_LIST);
		this.recordList.setRelations(DARIAHConstants.RELATIONS_LIST);
		this.recordList.setRights(DARIAHConstants.RIGHTS_LIST);
		this.recordList.setSources(DARIAHConstants.SOURCE_LIST);
		this.recordList.setSubjects(DARIAHConstants.SUBJECT_LIST);
		this.recordList.setTitles(DARIAHConstants.TITLE_LIST);
		this.recordList.setTypes(DARIAHConstants.TYPE_LIST);
		this.recordList.setFormatField(DARIAHConstants.FORMAT);
		this.recordList.setDateOfObjectCreation(DARIAHConstants.CREATED);
		this.recordList.setFieldForRange(DARIAHConstants.CREATED);
		this.recordList.setDateOfObjectCreation(DARIAHConstants.RANGE_FIELD);
		this.recordList.setFormatField("metadata.dc:format");
		this.recordList.setFormatToFilter("metadata");
		// this.recordList.setFormatToFilter("image/png");
		this.recordList
				.setRelationToFurtherMetadataObject("metadata.dc:relation");

		// cregId:hdl:6607/0000-0000-26A5-B
		// dariah:collection:6607/0000-0000-26A5-B
		JAXBElement<OAIPMHType> r = this.request.getRequest("ListRecords", "",
				"oai_dc", "", "", "", "");
		JAXB.marshal(r, System.out);
		System.out.println("-----------------------------------\n");
	}

	/**
	 * @throws ParseException
	 */
	@Test
	@Ignore
	public void testListMetadataFormats() throws ParseException {
		JAXBElement<OAIPMHType> r = this.request.getRequest(
				"ListMetadataFormats", "7t.0", "", "", "", "", "");
		JAXB.marshal(r, System.out);
		System.out.println("-----------------------------------\n");
	}

	/**
	 * @throws ParseException
	 */
	@Test
	@Ignore
	public void testListMetadataFormatsWithoutID() throws ParseException {
		JAXBElement<OAIPMHType> r = this.request.getRequest(
				"ListMetadataFormats", "", "", "", "", "", "");
		JAXB.marshal(r, System.out);
		System.out.println("-----------------------------------\n");
	}

	/**
	 * @throws ParseException
	 */
	@Test
	@Ignore
	public void testListSets() throws ParseException {

		JAXBElement<OAIPMHType> r = this.request.getRequest("ListSets", "", "",
				"", "", "", "");
		JAXB.marshal(r, System.out);
		System.out.println("-----------------------------------\n");
	}

	/**
	 * @throws ParseException
	 */
	@Test
	@Ignore
	public void testListIdentifiers() throws ParseException {
		this.identifierList.setFieldForRange(TGConstants.RANGE_FIELD);
		this.identifierList
				.setIdentifierListFields(TGConstants.IDENTIFIER_LIST_FIELDS);
		this.identifierList.setFormatField(TGConstants.FORMAT);
		this.identifierList.setFormatToFilter(TextGridMimetypes.EDITION);
		this.identifierList.setDateOfObjectCreation(TGConstants.CREATED);
		this.identifierList.setIdentifierField("textgridUri");
		this.identifierList.setRepositoryObjectURIPrefix("textgridUri:");

		JAXBElement<OAIPMHType> r = this.request.getRequest("ListIdentifiers",
				"", "oai_dc", "", "", "", "");
		JAXB.marshal(r, System.out);
		System.out.println("-----------------------------------\n");
	}

	@Test
	@Ignore
	public void testListIdentifiersDARIAH() throws ParseException {
		this.identifierList.setFieldForRange(DARIAHConstants.RANGE_FIELD);
		this.identifierList
				.setIdentifierListFields(DARIAHConstants.IDENTIFIER_LIST_FIELDS);
		this.identifierList.setFormatField(DARIAHConstants.FORMAT);
		// this.identifierList.setFormatToFilter(TextGridMimetypes.EDITION);
		this.identifierList.setDateOfObjectCreation(DARIAHConstants.CREATED);
		this.identifierList.setRepositoryObjectURIPrefix("hdl:");
		this.identifierList.setIdentifierField(DARIAHConstants.IDENTIFIER);

		JAXBElement<OAIPMHType> r = this.request.getRequest("ListIdentifiers",
				"", "oai_dc", "", "", "", "");
		JAXB.marshal(r, System.out);
		System.out.println("-----------------------------------\n");
	}

}
